<script setup lang="ts">
import { useBranchStore } from '@/stores/branch'
import { useRoleStore } from '@/stores/role'
import { useUserStore } from '@/stores/user'
import { onMounted, ref, watchEffect } from 'vue'
import type { VForm } from 'vuetify/components'

const refForm = ref<VForm | null>(null)
const userStore = useUserStore()
const roleStore = useRoleStore()
const branchStore = useBranchStore()

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await userStore.saveUser()
  userStore.closeDialog()
}
const imageURL = ref<any>(null)
watchEffect(() => {
  if (userStore.editedUser.files && userStore.editedUser.files.length > 0) {
    const reader = new FileReader()
    reader.onload = (event) => {
      imageURL.value = event.target?.result
    }
    reader.readAsDataURL(userStore.editedUser.files[0])
  } else {
    imageURL.value = null
  }
})
onMounted(async () => {
  await userStore.getUsers()
  await roleStore.getRoles()
  await branchStore.getBranches()
})
</script>

<template>
  <v-card>
    <v-card-title>
      <span class="text-h5">ข้อมูลพนักงาน</span>
    </v-card-title>
    <v-card-text>
      <v-form ref="refForm" v-model="userStore.form" @submit.prevent="userStore.onSubmit">
        <v-container>
          <v-card title="ประวัติ" variant="outlined">
            <div style="
                padding-left: 30px;
                padding-right: 30px;
                padding-top: 10px;
                padding-bottom: 10px;
              ">
              <v-row>
                <v-col cols="12" md="8">
                  <v-row>
                    <v-col cols="12">
                      <v-text-field v-model="userStore.editedUser.name" :readonly="userStore.loading" variant="outlined"
                        label="ชื่อ-นามสกุล" :rules="[(v) => !!v || 'Field is required']" class="mb-2"
                        clearable></v-text-field>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-text-field v-model="userStore.editedUser.birthDate" :readonly="userStore.loading"
                        variant="outlined" :rules="[(v) => !!v || 'Field is required']" clearable label="วันเดือนปีเกิด"
                        type="Date"></v-text-field>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-text-field v-model="userStore.editedUser.age" :readonly="userStore.loading" variant="outlined"
                        :rules="[(v) => !!v || 'Field is required']" clearable label="อายุ" placeholder="Enter your age"
                        type="number"></v-text-field>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-select v-model="userStore.editedUser.gender" clearable label="เพศ"
                        :items="['ชาย', 'หญิง', 'อื่นๆ']" variant="outlined"></v-select>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-select v-model="userStore.editedUser.bloodType" clearable label="หมู่เลือด" variant="outlined"
                        :items="['A+', 'A-', 'B+', 'B-', 'AB+', 'AB-', 'O+', 'O-']"></v-select>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-text-field v-model="userStore.editedUser.height" :readonly="userStore.loading"
                        :rules="[(v) => !!v || 'Field is required']" clearable label="Height (cm.)"
                        placeholder="Enter your Height" type="number" variant="outlined"></v-text-field>
                    </v-col>
                    <v-col cols="12" md="6">
                      <v-text-field v-model="userStore.editedUser.weight" :readonly="userStore.loading"
                        :rules="[(v) => !!v || 'Field is required']" clearable label="Weight (kg.)"
                        placeholder="Enter your Weight" type="number" variant="outlined"></v-text-field>
                    </v-col>
                  </v-row>
                </v-col>
                <v-col cols="12" md="4">
                  <v-row style="padding-bottom: 10px">
                    <v-img v-if="userStore.editedUser.files && userStore.editedUser.files.length > 0" :src="imageURL"
                      alt="Uploaded Image" width="200" height="200"></v-img>
                    <v-img v-else :src="'http://localhost:3000/images/users/' + userStore.editedUser.image" width="200"
                      height="200">
                    </v-img>
                  </v-row>
                  <v-row>
                    <v-file-input v-model="userStore.editedUser.files" :rules="[
                        (value) => {
                          return (
                            !value ||
                            !value.length ||
                            value[0].size < 2000000 ||
                            'Avatar size should be less than 2 MB!'
                          )
                        }
                      ]" accept="image/png, image/jpeg" placeholder="Pick an avatar" prepend-icon="mdi-image"
                      label="Avatar" variant="outlined"></v-file-input>
                  </v-row>
                </v-col>
                <v-row>
                  <v-col cols="12">
                    <v-textarea v-model="userStore.editedUser.address" :readonly="userStore.loading"
                      :rules="[(v) => !!v || 'Field is required']" clearable label="ที่อยู่" variant="outlined"
                      placeholder="Enter Address"></v-textarea>
                  </v-col>
                </v-row>
              </v-row>
            </div>
          </v-card>

          <v-card title="ช่องทางการติดต่อ" variant="outlined" style="margin-top: 20px">
            <div style="
                padding-left: 30px;
                padding-right: 30px;
                padding-top: 10px;
                padding-bottom: 10px;
              ">
              <v-row>
                <v-col cols="12" md="6">
                  <v-text-field v-model="userStore.editedUser.phone" :readonly="userStore.loading" variant="outlined"
                    :rules="[(v) => !!v || 'Field is required']" clearable label="เบอร์โทรศัพท์"
                    placeholder="xxx-xxx-xxxxx"></v-text-field>
                </v-col>
                <v-col cols="12" md="6">
                  <v-text-field v-model="userStore.editedUser.email" :readonly="userStore.loading" variant="outlined"
                    :rules="[(v) => !!v || 'Field is required']" clearable label="อีเมล" placeholder="Enter Email"
                    :type="'email'"></v-text-field>
                </v-col>
              </v-row>
            </div>
          </v-card>
          <v-card title="การงาน" variant="outlined" style="margin-top: 20px">
            <div style="
                padding-left: 30px;
                padding-right: 30px;
                padding-top: 10px;
                padding-bottom: 10px;
              ">
              <v-row>
                <v-col cols="12" v-if="userStore.newUser === true">
                  <v-text-field v-model="userStore.editedUser.password" :readonly="userStore.loading"
                    :rules="[(v) => !!v || 'Field is required']" label="รหัสผ่าน เข้าระบบ" placeholder="Enter password"
                    clearable variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12">
                  <v-select v-model="userStore.editedUser.branch" :items="branchStore.branches" item-title="name"
                    item-value="id" label="สาขา" return-object variant="outlined"></v-select>
                </v-col>
                <v-col cols="12" md="6">
                  <v-select v-model="userStore.editedUser.role" :items="roleStore.roles" item-title="name"
                    label="ตำเหน่งงาน" item-value="id" return-object variant="outlined"></v-select>
                </v-col>
                <v-col cols="12" md="6">
                  <v-text-field v-model="userStore.editedUser.salary" :readonly="userStore.loading"
                    :rules="[(v) => !!v || 'Field is required']" clearable label="เงินเดือน" placeholder="Enter Salary"
                    type="number" variant="outlined"></v-text-field>
                </v-col>
                <v-col cols="12" md="6">
                  <v-text-field v-model="userStore.editedUser.startDate" :readonly="userStore.loading"
                    :rules="[(v) => !!v || 'Field is required']" clearable label="วันที่เข้าทำงาน" variant="outlined"
                    type="Date"></v-text-field>
                </v-col>
                <v-col cols="12" md="6">
                  <v-select v-model="userStore.editedUser.status" clearable label="สถานะ"
                    :items="['ยังอยู่', 'ออกแล้ว']" variant="outlined"></v-select>
                </v-col>
              </v-row>
            </div>
          </v-card>
        </v-container>
      </v-form>
      <small>*indicates required field</small>
    </v-card-text>
    <v-card-actions>
      <v-spacer></v-spacer>
      <v-btn variant="text" @click="userStore.closeDialog()"> Close </v-btn>
      <v-btn variant="text" @click="save()"> Save </v-btn>
    </v-card-actions>
  </v-card>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 80px;
  display: flex;
  justify-content: center;
  align-items: center;
  color: black;
}

.custom-header {
  background-color: #ffcb5e;
}
</style>
